#include "../includes/prompt_and_read.h"

long cnt1 = 0, cnt2 = 0;
long fibonacci_n(int);
long fibonacci_dynamic(int);

int main(void) {

	int n = prompt_and_read_int("Enter number of fibonacci series elements");

	long fib1 = fibonacci_n(n);	//	substitution necessary due to sequential points
	long fib2 = fibonacci_dynamic(n);
	printf("%d: %ld (%ld function calls)\n", n, fib1, cnt1);
	printf("%d: %ld (%ld function calls)\n", n, fib2, cnt2);

	return EXIT_SUCCESS;
}

long fibonacci_n(int n) {
	++cnt1;
	if (n <= 1) return n;
	return fibonacci_n(n - 1) + fibonacci_n(n - 2);
} 

long fibonacci_dynamic(int n) {
	static long f[100] = { 0, 1 };
	++cnt2;
	if (n <= 1) return n;
	if(!f[n]) f[n] = fibonacci_dynamic(n - 1) + fibonacci_dynamic(n - 2);
	return f[n];
}

