#include "../includes/prompt_and_read.h"

double power1(double, int);
double power2(double, int);

int main(void) {
	double x = prompt_and_read_double("Enter x");
	int n = prompt_and_read_int("Enter n");

	for (int i = 0; i < n; i++)
		printf("power(%.4f, %d) = %10.4f\t%10.4f\n",
			x, i, power1(x, i), power2(x, i));

	return EXIT_SUCCESS;
}

double power1(double x, int n) {
	double p = 1.0;
	for (int i = 0; i < n; i++) p *= x;
	return p;
}

double power2(double x, int n) {
	double p = 1.0;
	while (n-- > 0) p *= x;
	return p;
}

