#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

int sum (int, ...);

int main(void) {

	printf("Sum of 1 2 3 and 4 = %d\n", sum(4, 1, 2, 3, 4));
	printf("Sum of 3 7 and 13 = %d\n", sum(3, 3, 7, 13));

	return EXIT_SUCCESS;
}

int sum (int number, ...) {
	int total = 0;
	va_list args;	//	list of arguments to be put here
	va_start (args, number);	//	put actual arguments to args;
	for (int k = 0; k < number; k++) {
		int n = va_arg (args, int);	//	extract next argument (of type int) from args
		total += n;
	}
	va_end (args);	//	final cleanup

	return total;
}
